#include <ros/assert.h>
#include <ros/console.h>

#pragma once

namespace schpin
{

#define SCHPIN_DEBUG_LOG( msg )          \
        {                                \
                ROS_DEBUG_STREAM( msg ); \
        }

#define SCHPIN_DEBUG_LOG_THROTTLE( period, msg )          \
        {                                                 \
                ROS_DEBUG_STREAM_THROTTLE( period, msg ); \
        }

#define SCHPIN_DEBUG_LOG_DELAYED_THROTTLE( period, msg )          \
        {                                                         \
                ROS_DEBUG_STREAM_DELAYED_THROTTLE( period, msg ); \
        }

#define SCHPIN_INFO_LOG_DELAYED_THROTTLE( period, msg )          \
        {                                                        \
                ROS_INFO_STREAM_DELAYED_THROTTLE( period, msg ); \
        }

#define SCHPIN_WARN_LOG( msg )          \
        {                               \
                ROS_WARN_STREAM( msg ); \
        }

#define SCHPIN_INFO_LOG( msg )          \
        {                               \
                ROS_INFO_STREAM( msg ); \
        }

#define SCHPIN_INFO_LOG_DELAYED_THROTTLE( period, msg )          \
        {                                                        \
                ROS_INFO_STREAM_DELAYED_THROTTLE( period, msg ); \
        }

#define SCHPIN_ASSERT( cond )       \
        {                           \
                ROS_ASSERT( cond ); \
        }
#define SCHPIN_ASSERT_MSG( cond, args )                                                 \
        {                                                                               \
                std::stringstream schpin_assert_stringstream;                           \
                schpin_assert_stringstream << args;                                     \
                ROS_ASSERT_MSG( cond, "%s", schpin_assert_stringstream.str().c_str() ); \
        }

}  // namespace schpin
