#include <nlohmann/json.hpp>

#pragma once

namespace schpin
{

struct Color
{
        float r = 0.f;
        float g = 0.f;
        float b = 0.f;
};

inline bool operator!=( const Color& lh, const Color& rh )
{
        return lh.r != rh.r && lh.g != rh.g && lh.b != rh.b;
}

inline void to_json( nlohmann::json& j, const Color& c )
{
        j["r"] = c.r;
        j["g"] = c.g;
        j["b"] = c.b;
}

inline void from_json( const nlohmann::json& j, Color& c )
{
        c.r = j["r"].get< float >();
        c.g = j["g"].get< float >();
        c.b = j["b"].get< float >();
}

}  // namespace schpin
