
#include <schpin_lib/physical_quantity.h>

#pragma once

namespace schpin
{

struct OccupancyTag : QuantityTag
{
        static char getUnit()
        {
                return 'o'; // ok, unit of this is %, but can we somehow implement 'scale' during print?
        }
};

using Occupancy = Quantity< NeutralRatio, OccupancyTag, float >;

using Distance = Length;
using Radius   = Length;

const Angle PI = Angle{float( std::acos( -1 ) )};

enum class Direction
{
        POS,
        NEG
};

}  // namespace schpin
