#include "base/triangle.h"

namespace schpin
{
template class Simplex< Point< 3 >, 2 >;
template class TriangleCollisionQuery< 3 >;

Point< 3 > getTriangleSphereCenter( const Triangle< 3 >& triangle )
{
        Point< 3 > AB     = triangle[0] - triangle[1];
        Point< 3 > AC     = triangle[0] - triangle[2];
        Point< 3 > normal = cross( AB, AC ).normalized();
        Point< 3 > pAB    = cross( normal, AB );
        Point< 3 > pAC    = cross( normal, AC );
        Point< 3 > cAC    = ( triangle[0] + triangle[2] ) / 2;
        Point< 3 > cAB    = ( triangle[0] + triangle[1] ) / 2;

        float k = pAB[0] * ( cAB[1] - cAC[1] ) + pAB[1] * ( cAC[0] - cAB[0] );
        //-------------------------------------------------------------------
        k /= ( pAB[0] * pAC[1] - pAC[0] * pAB[1] );

        return cAC + k * pAC;
}

}  // namespace schpin
