#include <schpin_lib/identificator.h>

#pragma once

namespace schpin
{
using BodyVertexID   = Identificator< struct BodyVertexIDTag, 32 >;
using BodyEdgeOffset = Identificator< struct BodyEdgeOffsetTag, 32 >;
using BodyPrice      = float;

struct BodyEdgeID
{
        BodyVertexID   vertex_id;
        BodyEdgeOffset edge_offset;
};

}  // namespace schpin

namespace std
{
template <>
struct hash< schpin::BodyVertexID >
{
        std::size_t operator()( const schpin::BodyVertexID& k ) const
        {
                return std::hash< schpin::BodyVertexID::ValueType >()( *k );
        }
};
}  // namespace std
