#include "body.h"

#pragma once

namespace schpin
{

struct BodyState
{
        Pose pose;
};

class BodyStateView
{

        const Body&      body_;
        const BodyState& state_;

      public:
        BodyStateView( const Body& body, const BodyState& state )
          : body_( body )
          , state_( state )
        {
        }

        const Body& getBody() const
        {
                return body_;
        }

        const Pose& getPose() const
        {
                return state_.pose;
        }
};

}  // namespace schpin
