#include "base/pose.h"
#include "body/edge.h"
#include "gait/vertex.h"
#include "graph/generics.h"
#include <schpin_lib/util.h>

#pragma once

namespace schpin
{

template < typename SearchContent >
struct BodyVertexContent
{
        SearchContent search_content;
        Pose          pose;

        BodyVertexContent( Pose pose )
          : search_content()
          , pose( pose )
        {
        }
};

template < typename VertexContent >
using BodyVertex = GenericVertex< BodyVertexID, VertexContent, BodyEdge >;

}  // namespace schpin
