#include "gait/base.h"
#include "gait/edge.h"
#include "graph/dstar/content.h"
#include "graph/generics.h"
#include "leg/base.h"
#include "leg/graph/base.h"
#include <schpin_lib/util.h>
#include <utility>
#include <variant>

#pragma once

namespace schpin
{
struct GaitMovingLeg
{
        LegVertexID actual_lid;
        Point< 3 >  target;
};

struct GaitStandingLeg
{
        LegVertexID lid;
        Point< 3 >  position;
};

using GaitLegVariant   = std::variant< GaitMovingLeg, GaitStandingLeg >;
using GaitLegContainer = LegContainer< GaitLegVariant >;

struct GaitState
{
        Pose             body_pose;
        GaitLegContainer legs;
};

template < typename SearchContent >
struct GaitVertexContent
{
        SearchContent search_content;
        GaitState     state;
};

template < typename VertexContent >
using GaitVertex = GenericVertex< GaitVertexID, VertexContent, GaitEdge >;

}  // namespace schpin
