#include <nlohmann/json.hpp>

#pragma once

namespace nlohmann
{
template < typename DStarConfig >
struct adl_serializer< schpin::AnytimeDStar< DStarConfig > >
{

        static void to_json( nlohmann::json& j, const schpin::AnytimeDStar< DStarConfig >& dstar )
        {
                j = nlohmann::json{{"graph", dstar.getGraph()}};
        }
        static schpin::AnytimeDStar< DStarConfig > from_json( const nlohmann::json& j )
        {
                using Graph             = typename DStarConfig::Graph;
                using HeuristicFunction = typename DStarConfig::HeuristicFunction;
                return schpin::AnytimeDStar< DStarConfig >( j["graph"].get< Graph >(), HeuristicFunction() );
        }
};
}  // namespace nlohmann
