#include <sstream>

#pragma once

namespace schpin
{

template < typename Graph >
std::string graphToDot( const Graph& g )
{

        std::stringstream ss;

        ss << "digraph G{" << std::endl;

        forEach( g.getVertexes(), [&]( const auto& vertex ) {
                forEach( vertex.getEdges(), [&]( const auto& edge ) {
                        ss << edge.getSourceID() << " ->  " << edge.getTargetID() << ";" << std::endl;
                } );
        } );

        ss << "}";

        return ss.str();
}

}  // namespace schpin
