#include "leg/graph/rviz.h"

namespace schpin
{

visualization_msgs::Marker createLegGraphMarker( const std::string& ns, unsigned id, const std::string& frame )
{
        visualization_msgs::Marker res;

        res.header.frame_id = frame;
        res.header.stamp    = ros::Time::now();

        res.ns = ns;
        res.id = int( id );

        res.type   = visualization_msgs::Marker::POINTS;
        res.action = visualization_msgs::Marker::ADD;

        res.pose.position.x    = 0;
        res.pose.position.y    = 0;
        res.pose.position.z    = 0;
        res.pose.orientation.x = 0.0;
        res.pose.orientation.y = 0.0;
        res.pose.orientation.z = 0.0;
        res.pose.orientation.w = 1.0;

        res.scale.x = 0.001;
        res.scale.y = 0.001;
        res.scale.z = 0.001;

        res.color.r = 1.0f;
        res.color.g = 0.0f;
        res.color.b = 0.0f;
        res.color.a = 1.0;

        res.lifetime = ros::Duration();

        return res;
}

}  // namespace schpin
