#include "collission_interfaces.h"
#include "leg.h"
#include <ros/ros.h>
#include <visualization_msgs/Marker.h>

#pragma once

namespace schpin
{

visualization_msgs::Marker createLegGraphMarker( const std::string& ns, unsigned id, const std::string& frame );

template < unsigned N >
visualization_msgs::Marker createLegGraphVisualization( const Leg< N >& leg )
{
        visualization_msgs::Marker res = createLegGraphMarker( leg.getName(), 1, leg.getFrame() );
        forEach( leg.getGraph(), [&]( const auto& vertex ) {
                Point< 3 > p = leg.getModel().tipPosition( vertex.getDiscreteAngles() );

                geometry_msgs::Point coord = pointToMsg( p );
                res.points.push_back( coord );
        } );
        return res;
}

}  // namespace schpin
