#include "leg.h"

#pragma once

namespace schpin
{

template < unsigned N >
struct LegState
{
        std::array< Angle, N > configuration;
};

template < unsigned N >
class LegStateView
{

        const Leg< N >&      leg_;
        const LegState< N >& state_;
        Point< 3 >           tip_position_;

      public:
        LegStateView( const Leg< N >& leg, const LegState< N >& state )
          : leg_( leg )
          , state_( state )
          , tip_position_()
        {
                tip_position_ = leg.getModel().tipPosition( state.configuration );
        }
        const Leg< N >& operator*() const
        {
                return leg_;
        }
        const Leg< N >* operator->() const
        {
                return &leg_;
        }

        const Point< 3 >& getTipPosition() const
        {
                return tip_position_;
        }
};

}  // namespace schpin
