#include "body/view.h"
#include "leg/view.h"
#include <utility>

#pragma once

namespace schpin
{
template < typename GaitGraph >
class RobotView
{
      public:
        using LegViewContainer = LegContainer< LegView< 3 > >;
        using LegConstIterator = typename LegViewContainer::const_iterator;

      private:
        LegViewContainer      leg_views_;
        BodyView< GaitGraph > body_view_;

      public:
        RobotView( LegViewContainer leg_views, BodyView< GaitGraph > body_view )
          : leg_views_( std::move( leg_views ) )
          , body_view_( std::move( body_view ) )
        {
        }

        Range< LegConstIterator > getLegViews() const
        {
                return range( leg_views_ );
        }

        const BodyView< GaitGraph >& getBodyView() const
        {
                return body_view_;
        }
};
}  // namespace schpin
