#include "collission.h"
#include "environment.h"
#include "leg/graph/rviz.h"
#include "octree/rviz.h"
#include "planner.h"
#include "robot.h"
#include <cmath>
#include <fstream>
#include <iostream>
#include <ros/console.h>
#include <ros/ros.h>

using namespace schpin;

int main( int argc, char* argv[] )
{

        ros::init( argc, argv, "planning_tester" );
        ros::NodeHandle handle{};

        ros::Publisher marker_array_pub =
            handle.advertise< visualization_msgs::MarkerArray >( "/visualization_marker_array", 10 );
        ros::Publisher marker_pub = handle.advertise< visualization_msgs::Marker >( "/visualization_marker", 10 );

        std::string model_filename;

        if ( !handle.getParam( "/world_model_filename", model_filename ) ) {
                return 1;
        }

        ros::Rate r( 1 );

        r.sleep();

        //  Environment env( model_filename );

        // env.logStats();

        // visualization_msgs::MarkerArray msg = createOcVisualization( env.getTree(), "map" );
        // marker_array_pub.publish( msg );
        ROSConfig cfg;

        auto robot_either = loadRobotROS( handle, cfg );

        // visualization_msgs::MarkerArray leg_map_msg = createOcVisualization( d.graph_mapping.getTree(), "leg/rl/coxa"
        // ); marker_array_pub.publish( leg_map_msg );

        // visualization_msgs::MarkerArray warea_msg = createOcVisualization( leg.getWorkarea(), leg.getFrame(), 0.75 );
        // marker_array_pub.publish( warea_msg );

        //  visualization_msgs::Marker graph_msg = createLegGraphVisualization( leg );
        // marker_pub.publish( graph_msg );
        ros::spinOnce();

        return 0;
}
