#include "base/point.h"
#include <gtest/gtest.h>

#pragma once

using namespace schpin;

template < typename IC >
class PointTest : public ::testing::Test
{
      public:
        static constexpr unsigned N = IC::value;

        void SetUp() override
        {

                std::array< float, N > zero_p_data;
                std::fill( zero_p_data.begin(), zero_p_data.end(), 0 );
                zero_p_ = Point< N >( std::move( zero_p_data ) );

                std::array< float, N > unit_p_data;
                std::fill( unit_p_data.begin(), unit_p_data.end(), 1 );
                unit_p_ = Point< N >( std::move( unit_p_data ) );

                std::array< float, N > dim_p_data;
                std::fill( dim_p_data.begin(), dim_p_data.end(), N );
                dim_p_ = Point< N >( std::move( dim_p_data ) );
        }

        Point< N > zero_p_;
        Point< N > unit_p_;
        Point< N > dim_p_;
};

using TestTypes = ::testing::Types< std::integral_constant< unsigned, 2 >,
                                    std::integral_constant< unsigned, 3 >,
                                    std::integral_constant< unsigned, 4 >,
                                    std::integral_constant< unsigned, 8 > >;

TYPED_TEST_CASE( PointTest, TestTypes );
