#include "base/simplex.h"
#include <gtest/gtest.h>

using namespace schpin;

TEST( SimplexTest, volume2d )
{
        std::array< Point< 2 >, 3 > data{Point< 2 >( 0, 1 ), Point< 2 >( 1, 0 ), Point< 2 >( 0, 0 )};

        Simplex< Point< 2 >, 2 > simplex( data );

        ASSERT_EQ( getVolume( simplex ), 0.5 );
}
TEST( SimplexTest, volume3d )
{
        std::array< Point< 3 >, 4 > data{
            Point< 3 >( 0, 0, 1 ), Point< 3 >( 1, 0, 0 ), Point< 3 >( 0, 0, 0 ), Point< 3 >{0, 1, 0}};

        Simplex< Point< 3 >, 3 > simplex( data );

        ASSERT_NEAR( getVolume( simplex ), 0.166667, 0.00001 );
}

TEST( SimplexTest, json )
{
        std::array< Point< 3 >, 4 > data{
            Point< 3 >( 0, 0, 1 ), Point< 3 >( 1, 0, 0 ), Point< 3 >( 0, 0, 0 ), Point< 3 >{0, 1, 0}};

        using SimplexT = Simplex< Point< 3 >, 3 >;

        SimplexT simplex( data );

        nlohmann::json simplex_j = nlohmann::json( simplex );
        ASSERT_EQ( simplex_j.get< SimplexT >(), simplex ) << simplex_j;
}
