#include "leg.h"
#include "leg/graph/gen.h"
#include "schpin_test/leg_test_util.h"
#include <gtest/gtest.h>

using namespace schpin;

TEST( Collision, SimplexTrianglesGraph )
{
        LegTestGraph< 2 > graph = genLegTestGraph< 2 >( 3 );

        Simplex< LegVertexID, 2 > s1{LegVertexID{1}, LegVertexID{3}, LegVertexID{4}};
        Simplex< LegVertexID, 2 > s2{LegVertexID{1}, LegVertexID{2}, LegVertexID{4}};

        SimplexGraphCollisionQuery< 2 > q1( graph, s1 );
        SimplexGraphCollisionQuery< 2 > q2( graph, s2 );

        EXPECT_FALSE( collides< 2 >( q1, q2 ) );
}
