/**
 * Copyright 2017 by Jan Koniarik <jan.koniarik@gmail.com>
 * 
 * This file is part of Schpin.
 * 
 * Schpin is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Schpin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Schpin.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @license LPGL-3.0+ <https://www.gnu.org/licenses/lgpl.html>
 */
#include "leg.h"
#include "solver/axis.h"
#include <tuple>

#pragma once

namespace schpin
{

class Config
{
  // TODO: so for every place LegMap used, we need to connect signal to adding/removing items into map
  std::tuple< solver::XAxis, solver::YAxis, solver::ZAxis, solver::YawAxis, solver::RollAxis, solver::PitchAxis > axes_;

public:
  template < typename Axis >
  const Axis& getAxis() const
  {
    return std::get< Axis >( axes_ );
  };

  template < typename Axis >
  double getValue( const typename Axis::Point& point ) const
  {
    return getAxis< Axis >().getValue( point );
  }
};
}
