/**
 * Copyright 2017 by Jan Koniarik <jan.koniarik@gmail.com>
 * 
 * This file is part of Schpin.
 * 
 * Schpin is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Schpin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Schpin.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @license LPGL-3.0+ <https://www.gnu.org/licenses/lgpl.html>
 */
#include "leg/base.h"
#include "leg/graph.h"
#include "leg/sidepath.h"

#pragma once

namespace schpin
{
namespace leg
{

  struct ConfigData
  {
    std::vector< SidepathDistance > step_move_distances{0.02, 0.03, 0.04};
  };

  class Config
  {
    ConfigData data_;

  public:
    Config()
      : data_()
    {
    }
    Config( ConfigData data )
      : data_( data )
    {
    }

    const std::vector< SidepathDistance > & getMoveDistances() const
    {
      return data_.step_move_distances;
    }
  };
}
}
