#include "leg/graph.h"
#include "graph/util/iterator.h"
#include <gtest/gtest.h>

namespace schpin
{
namespace test
{
  template < typename Algorithm >
  graph::VertexIterator< Algorithm > verifyVertexOrder( GraphData & data )
  {

    std::vector< leg::VertexID > order;

    std::copy( data.vertex_order->rbegin(), data.vertex_order->rend(), std::back_inserter( order ) );

    std::shared_ptr< Algorithm > ptr = std::make_shared< Algorithm >( data.graph, *data.start );

    graph::VertexIterator< Algorithm > begin( ptr, ptr->begin() );
    graph::VertexIterator< Algorithm > end( ptr, ptr->end() );

    for ( ; begin != end; ++begin )
    {
      leg::Vertex& vertex = *begin;
      EXPECT_FALSE( order.empty() );

      EXPECT_EQ( vertex.getID(), order.back() );
      order.pop_back();
    }

    EXPECT_TRUE( order.empty() );

    return begin;
  };
}
}
